/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/

package Question2;


public class StackFromQueue {
	  /* Instance Fields */
	private QueueSLL StackQ;
	
	
	  /* Constructor */
	public StackFromQueue(){
		StackQ = new QueueSLL();
	}
	
	public StackFromQueue(Object o){
		StackQ = new QueueSLL(o);
	}
	
	
	
	
	/*	Methods	*/
	
	// The Q will be kept in reversed order (LIFO). This is done at insertion such that
	// both pop and peek don't have to do it
	  public void push(Object o){
		  // Create a new Q with the new element
		  QueueSLL tempQ = new QueueSLL();

		  // Add the new element in the Q
		  tempQ.enqueue(o);
		  
		  // Reverse the order of the stack into a temp Q
		  while(!StackQ.isEmpty())
			  tempQ.enqueue(StackQ.dequeue());
		  

		  // The reverse the order a second time. 
		  // The element is now the oldest in the Q = top of stack
		  while(!tempQ.isEmpty())
			  StackQ.enqueue(tempQ.dequeue());
	  }
		  
	  
	  
	  public Object pop(){
		  return StackQ.dequeue();
	  }
		  
	  public Object peek(){
		  return StackQ.peek();
	  }
		  
	  public boolean isEmpty(){
		  return StackQ.isEmpty();
	  }

	  
	  /*
	  // Test
	  public static void main(String[] args){
	
		  StackFromQueue NewStack = new StackFromQueue();
		  NewStack.push("Testing");
		  NewStack.push("ONE");
		  NewStack.push("TWO");
		  NewStack.push(new Integer(69));
		  System.out.println(NewStack.peek());
		  System.out.println(NewStack.peek());
		  System.out.println(NewStack.pop());
		  System.out.println(NewStack.pop());
		  NewStack.push("NewElement");
		  System.out.println(NewStack.pop());
		  System.out.println(NewStack.pop());
		  System.out.println(NewStack.pop());
		  System.out.println(NewStack.pop());
	  }
	  */
}
