/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/

package Question4;



public class QueueSLL {

	  /* instance fields */
	  Object value;
	  QueueSLL front, back, next;

	  /* Constructors */
	  public QueueSLL(){
		  front = back = next = null;
	  }
	  
	  public QueueSLL(Object o){
		  value = o;
		  next = null;
	  }
	
	  
	  /* Methods	*/
	  
		public void enqueue(Object o){
			// If the Q is empty, make it with a single element
	        if(isEmpty( ))    
	            back = front = new QueueSLL(o);
	        // Otherwise, insert new element at the back of the Q
	        else                // Regular case
	            back = back.next = new QueueSLL(o);
		}

		
		public Object dequeue(){
	        if(isEmpty( ))
	            return null;
	        
	        Object returnValue = front.value;
	        front = front.next;
	        return returnValue;
		}

		
		public Object peek(){
	        if(isEmpty( ))
	            return null;
	        
	        return front.value;
		}

		public boolean isEmpty(){
	        return front == null;
		}
	
		
		
		  // To test
		  public static void main(String[] args){
			  QueueSLL q = new QueueSLL();
			  q.enqueue("Testing");
			  q.enqueue("ONE");
			  q.enqueue("TWO");
			  q.enqueue(new Integer(69));
			  System.out.println(q.peek());
			  System.out.println(q.peek());
			  System.out.println(q.peek());
			  System.out.println(q.dequeue());
			  q.enqueue("TREE");
			  System.out.println(q.dequeue());
			  q.enqueue("FOUR");
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());

		  }
		
		
		
}
